#pragma once

#include "..\..\DuiLib\UIlib.h"
#include "DuiDefine.h"
#include "UserImageActor.h"

#define MSG_INACTIVE_HIDE	(WM_USER + 9300)
#define MSG_ACTIVE_PRARENT	(WM_USER + 9301)

typedef std::map<int, int>	GROUP_MEMU_LIST;

class CProfileWnd : public WindowImplBase, 
	private IGTWASActorEvent ,
	private IGTMessengerActorEvent,
	public IUserImageActorObserver
{
    DUI_DECLARE_MESSAGE_MAP()
    DUI_DECLARE_CUSTOM_MSG_MAP()
public:
	CProfileWnd();
	~CProfileWnd();

	LPCTSTR GetWindowClassName() const;
	void InitWindow();
	void OnPrepare(TNotifyUI& msg);
	void SetClientRect(CRect rc);
	void SetRequestID(LPCTSTR strID);
	void MakeIPTMenu( NTIPTStatusType iptMyStatus, NTIPTStatusType iptStatusOfBuddy, const NE_MEMBER_DATA* pMembereData, CMenu* pPopup );
	NTIPTStatusType GetMemberIPTStatus(LPCWSTR strUserID);
	void OnMenuIPT(WPARAM wParam);
	void CallToIPT(NE_MEMBER_DATA userData, CString strTel);
	void SetParentHwnd(HWND hParentWnd);
	HWND GetParentHwnd();
	void SetLayerBkImage(LPCTSTR lpszName);
	BOOL IsAllIdsInBuddyGroup(CStringList& selectedIdList, int nGroupID);
	BOOL IsSelectFavoriteBtn(CButtonUI *pBtn);
	BOOL GetEnableClose();
	BOOL CloseProfileWnd();
	void OnBtnFavoriteAdd(TNotifyUI& msg);
	void OnBtnFavoriteDelete(CString strUserID);
	void SetBookmark(int nOpType);
	CString ParseRelatedWorker(CString strRelateWorker);
	void OnNotifySetCurSor(TNotifyUI& msg);

	virtual CDuiString GetSkinFile();
	virtual CDuiString GetSkinFolder();
	virtual void OnFinalMessage(HWND hWnd);
	virtual LRESULT OnKillFocus(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);
	virtual LRESULT OnNcHitTest(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);

	virtual void OnUserImageActor_OnResponseUserImageInfo(CString strUserId);
	virtual bool OnGTWASActor_ResponseGetEmployeeInfo(IGTWASActor *pActor, trid_t trid, GTWASCallErrorCode eErrorCode, const NE_MEMBER_DATA_LIST &list, NTRequestEmpInfoType reqEmpInfoType, int nGroupID);

private:
	static UINT _DownloadThread(LPVOID pParam);
	static void CALLBACK _OnStatusCallBack(HINTERNET hInternet, DWORD_PTR dwContext, DWORD dwInternetStatus, LPVOID lpvStatusInformation, DWORD dwStatusInformationLength);

	void DownloadPicture(CString strURL);
	void DownloadThread();
	void CloseAllInternetHandle();
	void UpdateProfileImage(CString strUserId);
	int  GetStringInRect(CLabelUI *pLabelCtrl, LPCTSTR strText, SIZE szAvailable, int &nLeft, int nPixel);
	CControlUI* CreateControl(LPCTSTR pstrClass);
	
private:
	BOOL			m_bEnableClose;
	BOOL			m_bClosing;
	CRect			m_rcClient;
	CDuiString		m_strID;
	trid_t			m_trid;
	NE_MEMBER_DATA	m_userData;
	CDuiString		m_strMyID;
	CWinThread*		m_pImageDownloadThread;

	CString			 m_sServer; 
	CString			m_sObject; 
	//INTERNET_PORT	m_nPort;
	//DWORD			m_dwServiceType;
	HINTERNET		m_hInternetSession;
	HINTERNET		m_hHttpConnection;
	HINTERNET		m_hHttpFile;
	BOOL			m_bAbort;
	BOOL			m_bSafeToClose;
	CFile			m_FileToWrite;
	HWND			m_hParentWnd;
	GROUP_MEMU_LIST m_GroupList;
	SIZE			m_szBtnReleteWorker[2];
	CString			m_strBtnReleteWorker[2];
private:
    void _OnNotifyMenu(TNotifyUI& msg);
    void _OnNotifyBtnDown(TNotifyUI& msg);
    void _OnNotifyBtnCloseClick(TNotifyUI& msg);
	void _OnNotifyBtnRelateWorkerClick(TNotifyUI& msg);
    void _OnNotifyBtnFavoriteClick(TNotifyUI& msg);
    void _OnNotifyBtnChatClick(TNotifyUI& msg);
    void _OnNotifyBtnMailClick(TNotifyUI& msg);
    void _OnNotifyBtnSMSClick(TNotifyUI& msg);
    void _OnNotifyBtnPhoneClick(TNotifyUI& msg);

    LRESULT _OnMsgUserImageUpdated(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);
    LRESULT _OnMsgKeyDown(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);
    LRESULT _OnMsgSysKeyDown(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);

    LRESULT _OnMsgActivate(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);

    LRESULT _OnCommandRangeUserId(UINT uNotifyCode, int nID, HWND wndCtl, BOOL& bHandled);
    LRESULT _OnCommandMnCreateFavoriteGroup(UINT uNotifyCode, int nID, HWND wndCtl, BOOL& bHandled);
};

extern CProfileWnd *g_pProfileWnd;